/***************************************************************************
 *
 * ev_inmap.cc
 *      - template definitions for RW_VMapAssoc<StdColl,RWColl,Key,T>
 * 
 * $Id: ev_inmap.cc,v 7.1 1996/02/23 21:46:00 jims Exp $
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ****************************************************************************
 * 
 * $Log: ev_inmap.cc,v $
 * Revision 7.1  1996/02/23 21:46:00  jims
 * Move to revision 7.1
 *
 * 
 ****************************************************************************/


#define TEMPLATE template <class StdColl, class RWColl, class Key, class T>
#define VMA      RW_VMapAssoc<StdColl, RWColl, Key, T>

// handy macros, #undef'd below
#define KEY(i)    ((*i).first)
#define DATA(i)   ((*i).second)


TEMPLATE void
VMA::apply(void (*fn)(const Key&, T&, void*), void* x)
{
  for(iterator i = begin(); i != end(); ++i)
    (*fn)(KEY(i), DATA(i), x);
}

TEMPLATE void
VMA::apply(void (*fn)(const Key&, const T&, void*),void*x) const
{
  for(const_iterator i = begin(); i != end(); ++i)
    (*fn)(KEY(i), DATA(i), x);
}


TEMPLATE bool
VMA::remove(bool (*fn)(VMA::const_reference,void*),void* x)
{
  iterator hit = begin();
  for(/**/; hit != end(); ++hit) {
    if((*fn)(*hit,x)) {
      std().erase(hit);
      return true;
    }
  }
  return false;
}


TEMPLATE VMA::size_type
VMA::removeAll(bool (*fn)(VMA::const_reference, void*), void* x)
{
  size_type    ret = entries();
  
  while (entries() && (*fn)(*begin(),x))
    std().erase(begin());


  iterator iter(begin());
  iterator iter2;

  while (iter != end()) {
    iter2 = iter;
    ++iter2;
    if (iter2 != end() && (*fn)(*iter2,x))
      std().erase(iter2);
    else
      ++iter;
  }

  return ret - entries();
}

#undef KEY
#undef DATA

#undef TEMPLATE
#undef VMA
